//---------------------------------------------------------------------------
#ifndef RadarH
#define RadarH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <Graphics.hpp>
#include "math.h"
#include "mmsystem.h"

//---------------------------------------------------------------------------

enum TSoundOptions{soSystemOk=0,soSystemHand,soSystemQuestion,soSystemExclamation,soSystemAsterisk,soInternalSpeaker,soUserFile};
class PACKAGE TSound:public TPersistent
{
private:
 bool FEnabled;
 TSoundOptions FOptions;
 String FSoundFile;
void __fastcall SetEnabled(bool Value);

protected:
public:
void __fastcall Assign(TPersistent *Value);
 void __fastcall SetSoundFile(String Value);
void __fastcall SetOptions(TSoundOptions Value);
__published:
__property AnsiString UserSoundFile={read=FSoundFile,write=SetSoundFile};
__property bool Enabled={read=FEnabled,write=SetEnabled};
__property TSoundOptions Options={read=FOptions,write=SetOptions};

};

//========================-----------------------------

class PACKAGE TTarget:public TPersistent
{
private:
int FBearing;
int FDistance;
TColor FColor;
bool FDrawTarget;
protected:
public:
void __fastcall Assign(TPersistent *Value);
void __fastcall SetBearing(int Value);
void __fastcall SetDistance(int Value);
__published:
__property int Bearing={read=FBearing,write=SetBearing};
__property int Distance={read=FDistance,write=SetDistance};
__property TColor Color={read=FColor, write=FColor};
__property bool DrawTarget={read=FDrawTarget,write=FDrawTarget,default=true};

} ;

//======================--------------------------------
class PACKAGE TRadar : public TCustomControl
{
private:

Graphics::TBitmap *BackDraw;
TColor FBackColor;
TTimer *FTimer;
int FAngle;
int FInterval;
bool FEnabled;
int FRange;
bool FDrawTarget;
TNotifyEvent FOnAquireTarget;


void __fastcall StyleChanged(TObject* Sender);
void __fastcall RestartTimer(TObject* Sender);


virtual void __fastcall Paint(void);

protected:


public:


__fastcall TRadar(TComponent* Owner);
__fastcall virtual ~TRadar(void);

__published:
    TTarget* FTarget;
    TPen* FPen;
    TBrush* FBrush;
    TSound *FSound;
    void __fastcall SetBrush(TBrush* Value);
    void __fastcall SetPen(TPen* Value);
    void __fastcall SetBackColor(TColor Value);
    void __fastcall SetAngle(int);
    void __fastcall SetInterval(int);
    void __fastcall SetEnabled(bool);
    void __fastcall SetTarget(TTarget* Value);
   void __fastcall SetSound(TSound* Value);
__property TSound *Sound={read=FSound,write=SetSound};
  __property int Range={read=FRange,write=FRange,default=1000};
  __property TTarget *Target={read=FTarget,write=SetTarget};
  __property bool InternalSweepEnabled={read=FEnabled,write=SetEnabled,nodefault};
  __property int SweepRate={read=FInterval,write=SetInterval,default=1000};
  __property TBrush* Brush = {read=FBrush, write=SetBrush, nodefault};
  __property TPen* Pen = {read=FPen, write=SetPen, nodefault};
  __property int SweepAngle={read=FAngle,write=SetAngle,nodefault};
    __property TColor BackGroundColor={read=FBackColor,write=SetBackColor,nodefault};
  __property TNotifyEvent OnAquireTarget={read=FOnAquireTarget,write=FOnAquireTarget};
  __property Cursor;
  __property Visible;
   __property TabOrder;
  __property TabStop;
  __property Align;
  __property OnClick;
  __property OnDragDrop;
  __property OnDragOver;
  __property OnEndDrag;
  __property OnDblClick;
 __property OnMouseUp;
 __property OnMouseDown;
 __property OnMouseMove;
};

#define PI 3.1415926535897932385
//---------------------------------------------------------------------------
#endif
 